<template>
  <div class="">
    <div v-if="hasPermission">
      <el-button type="warning" plain round @click="editSong" icon="el-icon-edit">Edit</el-button>
      <el-button type="danger" plain round @click="deleteSong(song.id)" icon="el-icon-delete">Delete</el-button>
    </div>

    <h1>{{song.name}}</h1>
    <div v-html="song.content"></div>
  </div>
</template>

<script>
    import Requester from "@/controllers/requests/song.js";
    import auth from "@/controllers/requests/auth.js";

    const requester = new Requester();

    export default {
        name: "Detail",
        data() {
            return {
                song: {},
                hasPermission: false,
            }
        },
        created() {
            this.getContent();
        },

        mounted() {
            this.$root.$on("changedUserLogState", () => {
                this.checkUserPermission()
            });
        },

        methods: {
            getContent() {
                const id = this.$route.params.id;
                requester.getSongDetail(id).then(result => {
                    this.song = result;
                    this.song.category_id = [];
                    for (let category of this.song.category) {
                        this.song.category_id.push(category.id);
                    }
                    this.checkUserPermission();
                });
            },
            editSong() {
                this.$router.push({
                    name: 'EditorEdit',
                    params: {
                        song: this.song
                    }
                });
            },
            deleteSong(id) {
                this.$confirm('This will permanently delete the song. Continue?', 'Warning', {
                    confirmButtonText: 'Delete',
                    cancelButtonText: 'Cancel',
                    type: 'error'
                }).then(() => {
                    requester.deleteSong(id).then(() => {
                        this.$notify.success({
                            title: 'Success',
                            message: 'Song was deleted.'
                        });
                        this.$router.push({name: 'home'});
                        return true;
                    }).catch(err => {
                        this.$notify.error({
                            title: 'Error',
                            message: err
                        });
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: 'Delete canceled'
                    });
                });
            },
            checkUserPermission() {
                auth.isCreator(this.song.creator_id).then(() => {
                    this.hasPermission = true;
                }).catch(() => {
                    this.hasPermission = false;
                });
            }
        }
    }
</script>

<style scoped>

</style>
